ByteQueue::Walker Class Reference

A ByteQueue iterator. More...

`#include <queue.h>`

Inheritance diagram for ByteQueue::Walker:

## Public Member Functions

| Walker (const ByteQueue &queue)
| Construct a ByteQueue Walker.
lword | GetCurrentPosition ()
lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval.
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation.
size_t | Get (byte &outByte)
| Retrieve a 8-bit byte.
size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes.
size_t | Peek (byte &outByte) const
| Peek a 8-bit byte.
size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes.
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation.
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation.
Public Member Functions inherited from InputRejecting< BufferedTransformation >
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input a byte array for processing.
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation.
bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation.
size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel.
bool | ChannelMessageSeriesEnd (const std::string &channel, int messageEnd, bool blocking)
| Marks the end of a series of messages on a channel.
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object.
virtual bool | Attachable ()
| Determines whether the object allows attachment.
virtual BufferedTransformation * | AttachedTransformation ()
| Returns the object immediately attached to this object.
virtual const BufferedTransformation * | AttachedTransformation () const
| Returns the object immediately attached to this object.
virtual void | Detach (BufferedTransformation *newAttachment=NULL)
| Delete the current attachment chain and attach a new one.
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain.
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing.
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing.
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing.
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing.
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing.
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller.
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee.
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee.
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object.
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message.
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee.
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects.
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation.
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation.
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation.
virtual void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals.
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value.
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval.
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word.
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word.
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word.
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word.
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word.
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word.
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer.
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation.
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation.
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval.
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object.
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval.
virtual bool | GetNextMessage ()
| Start retrieving the next message.
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages.
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation.
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation.
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation.
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation.
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series.
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series.
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series.
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation.
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation.
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel.
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel.
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel.
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel.
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel.
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel.
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message.
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message.
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller.
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel.
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel.
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object.

## Detailed Description

A ByteQueue iterator.

Definition at line 164 of file queue.h.

## Constructor & Destructor Documentation

## Walker()

ByteQueue::Walker::Walker | ( | const ByteQueue & | queue | ) |

inline

Construct a ByteQueue Walker.

Parameters

  queue | a ByteQueue

Definition at line 169 of file queue.h.

## Member Function Documentation

## GetCurrentPosition()

lword ByteQueue::Walker::GetCurrentPosition | ( |  | ) |

inline

Definition at line 173 of file queue.h.

## MaxRetrievable()

lword ByteQueue::Walker::MaxRetrievable | ( |  | ) | const

inline virtual

Provides the number of bytes ready for retrieval.

Returns
  the number of bytes ready for retrieval

The number of bytes available are dependent on the source. If an exact value is available, then the exact value is returned. The exact value can include 0 if the source is exhausted.

Some stream-based sources do not allow seeking() on the underlying stream, such as some FileSource(). If the stream does not allow seeking() then MaxRetrievable() returns LWORD_MAX to indicate there are still bytes to be retrieved.

Reimplemented from BufferedTransformation.

Definition at line 175 of file queue.h.

## IsolatedInitialize()

void ByteQueue::Walker::IsolatedInitialize | ( | const NameValuePairs & | parameters | ) |

virtual

Initialize or reinitialize this object, without signal propagation.

Parameters

  parameters | a set of NameValuePairs to initialize this object

Exceptions

  NotImplemented |

IsolatedInitialize() is used to initialize or reinitialize an object using a variable number of arbitrarily typed arguments. The function avoids the need for multiple constructors providing all possible combintations of configurable parameters.

IsolatedInitialize() does not call Initialize() on attached transformations. If initialization should be propagated, then use the Initialize() function.

If a derived class does not override IsolatedInitialize(), then the base class throws NotImplemented.

Reimplemented from BufferedTransformation.

## Get() [1/2]

size_t ByteQueue::Walker::Get | ( | byte & | outByte | ) |

virtual

Retrieve a 8-bit byte.

Parameters

  outByte | the 8-bit value to be retrieved

Returns
  the number of bytes consumed during the call.

Use the return value of Get to detect short reads.

Reimplemented from BufferedTransformation.

## Get() [2/2]

size_t ByteQueue::Walker::Get | ( | byte * | outString,
|  | size_t | getMax )

virtual

Retrieve a block of bytes.

Parameters

  outString | a block of bytes
  getMax | the number of bytes to Get

Returns
  the number of bytes consumed during the call.

Use the return value of Get to detect short reads.

Reimplemented from BufferedTransformation.

## Peek() [1/2]

size_t ByteQueue::Walker::Peek | ( | byte & | outByte | ) | const

virtual

Peek a 8-bit byte.

Parameters

  outByte | the 8-bit value to be retrieved

Returns
  the number of bytes read during the call.

Peek does not remove bytes from the object. Use the return value of Get() to detect short reads.

Reimplemented from BufferedTransformation.

## Peek() [2/2]

size_t ByteQueue::Walker::Peek | ( | byte * | outString,
|  | size_t | peekMax ) const

virtual

Peek a block of bytes.

Parameters

  outString | a block of bytes
  peekMax | the number of bytes to Peek

Returns
  the number of bytes read during the call.

Peek does not remove bytes from the object. Use the return value of Peek() to detect short reads.

Reimplemented from BufferedTransformation.

## TransferTo2()

size_t ByteQueue::Walker::TransferTo2 | ( | BufferedTransformation & | target,
|  | lword & | byteCount,
|  | const std::string & | channel = DEFAULT_CHANNEL,
|  | bool | blocking = true )

virtual

Transfer bytes from this object to another BufferedTransformation.

Parameters

  target | the destination BufferedTransformation
  byteCount | the number of bytes to transfer
  channel | the channel on which the transfer should occur
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the transfer block (i.e., bytes not transferred)

TransferTo2() removes bytes from this object and moves them to the destination. Transfer begins at the index position in the current stream, and not from an absolute position in the stream.

byteCount is an IN and OUT parameter. When the call is made, byteCount is the requested size of the transfer. When the call returns, byteCount is the number of bytes that were transferred.

Implements BufferedTransformation.

## CopyRangeTo2()

size_t ByteQueue::Walker::CopyRangeTo2 | ( | BufferedTransformation & | target,
|  | lword & | begin,
|  | lword | end = LWORD_MAX,
|  | const std::string & | channel = DEFAULT_CHANNEL,
|  | bool | blocking = true ) const

virtual

Copy bytes from this object to another BufferedTransformation.

Parameters

  target | the destination BufferedTransformation
  begin | the 0-based index of the first byte to copy in the stream
  end | the 0-based index of the last byte to copy in the stream
  channel | the channel on which the transfer should occur
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the copy block (i.e., bytes not copied)

CopyRangeTo2 copies bytes from this object to the destination. The bytes are not removed from this object. Copying begins at the index position in the current stream, and not from an absolute position in the stream.

begin is an IN and OUT parameter. When the call is made, begin is the starting position of the copy. When the call returns, begin is the position of the first byte that was not copied (which may be different than end). begin can be used for subsequent calls to CopyRangeTo2().

Implements BufferedTransformation.

The documentation for this class was generated from the following file:

- queue.h